/*
 * collector_nowait.c
 *                   Dummy collector for nova development
 *
 *              version 0.33  28-AUG-1992 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.03  05-OCT-1992 Masaharu NOMACHI   (KEK)
 */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "nova.h"

#define DEFAULT_NAME          "/tmp/nova"
#define DEFAULT_SIGNIFICANCE  70
#define PRI_COLLECTOR         -1

main(argc, argv)
int argc;
char *argv[];
{
    struct NOVAD *nd;
    int *data, length;
    int status, loop, i, significance;
    char name[NV_MAXNAME + 1];

    strcpy(name, (argc > 1) ? argv[1] : DEFAULT_NAME);
    significance = (argc > 2) ? atoi(argv[2]) : DEFAULT_SIGNIFICANCE; 

    if ((int)(nd = nova_open(name, PRI_COLLECTOR,1)) == -1) {
	printf("collector: cannot open %s", name);
	exit(1);
    }

    loop = 0;
    while(1) {
      status = nova_get_nowait(nd, &data, &length);
      switch (status) {
      case 0:   /* nomal */
	loop++;
	printf("collector: loop=%d  status=%d  length=%d byte\n",
	       loop, status, length);
	for(i = 0; i < 100; i++)  data[i] = loop + i;
	status = nova_put(nd, data, 400, significance);
	break;
      case 1:   /* timeout */
	printf("collector: timeout!\n");
	break;
      default:  /* error */
	printf("collector: error!\n");
	break;
      }
      if (status < 0) break;
      sleep(3);
    }
    
    printf("collector: nomal end.\n");
    nova_close(nd);
}
